#!/usr/bin/perl -w

############################################################
# Programm zum parsen von UDCF Dateien
# Autor: Helmut Fahrion
# E-Mail: hefa@gmx.net
# Lizenz: GPL
# Datum: 12.2003
#############################################################

use XML::Parser;

$begin_samples 	= 0;
$begin_time	= 0;
$begin_depth	= 0;
$timedepthmode	= 0;

#--- Eingabefile ---
$parsefile	= $ARGV[0];

# --- Ausgabefile = Input fr deko.c ---
$outfile  = "deko-real.txt";

$time 	= 0.0;
$depth 	= 0.0;


print "udcf outfile: $outfile\n";

open(D, ">$outfile") || die "Fehler beim schreiben der Datei $outfile\n";


# ------ Starte Parser ------------


$p = new XML::Parser(Style => 'Stream');


$p->setHandlers(
	Start => \&start,
	Char => \&char,
	End => \&end,
	);

$p->parsefile($parsefile);



close (D);

# --- Programmende ---

sub start
{

   # --- erstmal nur diesen Mode untersttzen ---
   if ( $_[1] eq "timedepthmode" )
   {
     $timedepthmode = 1;
   }

   # --- section samples ---
   if ( ($_[1] eq "samples") && $timedepthmode )
   {
     $begin_samples = 1;

     print D "### generated by deko-udcfread.pl ###\n";
     print D "### sourcefile is $parsefile ###\n";
     
     return;
   }  
   
   # --- section zeit ---
   if ( $_[1] eq "t" )  
   {
     $begin_time = 1;
     return;
   }

   # --- section depth ---
   if ( $_[1] eq "d" )  
   {
     $begin_depth = 1;
     return;
   }
   
}

sub char
{
  if ( $begin_samples )
  {
    if ( $begin_time )
    {
	$time = $_[1];
	return;
    }
    if ( $begin_depth )
    {
	$depth = $_[1];
	return;
    }
  }
}

sub end
{
  if ( $begin_samples )
  {
    if ( $begin_time )
    {
	if ( $_[1] eq "t" )
	{
	  $begin_time = 0;
	}
	return;
    }
    
    if ( $begin_depth )
    {
	if ( $_[1] eq "d" )
	{
	  $begin_depth = 0;
	}

        # Ausgabe in time depth format
	print D "$depth $time\n";
	return;
    }

    #--- darf beim switch nicht abbrechen ---
    if ( $_[1] eq "work" )
    {
      return;
    }
    if ( $_[1] eq "alarm" )
    {
      return;
    }
    if ( $_[1] eq "switch" )
    {
      return;
    }
    
    #--- bricht bei jeden anderen schliessenden tag ab ---
    $begin_samples = 0;
    print "\n";
  }
}





